import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;
/**
 * Write a description of class Mouse here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Mouse extends Actor
{
    private int speed;

    private int score;

    public Mouse()
    {
        speed = 2;
    }    

    /**
     * Act - do whatever the Mouse wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        score = score +1;
        int mousex = getX();
        int mousey = getY();
        int positionupwall = 480 - mousey;
        if (positionupwall < 0)
        {
            positionupwall=0;
        }
        int offset = (int)Math.ceil(positionupwall/4);        
        int minleft = 12 + offset;
        int maxleft = 788 - offset;

      
        if (Greenfoot.isKeyDown("left") && mousex>minleft)
        {
            setLocation(getX()-speed, getY());
        }

        if (mousex<minleft)
        {
            setLocation(minleft, getY());
        }

        if (Greenfoot.isKeyDown("right") && mousex<maxleft)
        {
            setLocation(getX()+speed, getY());
        }

        if(mousex>maxleft)
        {
            setLocation(maxleft, getY());
        }

        if (Greenfoot.isKeyDown("up") && mousey>70)
        {
            setLocation(getX(), getY()-speed);
        }

        if (Greenfoot.isKeyDown("down") && mousey<580)
        {
            setLocation(getX(), getY()+speed);
        }

        Actor cheese = getOneIntersectingObject(Cheese.class);

        if (cheese != null)
        {
            getWorld().removeObject(cheese);  
            score = score + 100;
            speed = speed +1;

        }

        if (isMousetrapInRange())
        {
            whoWins("Game Over. \n Score: "+score);
            Greenfoot.stop();
        }

        if (isCatInRange())
        {
            whoWins("Game Over. \n Score: "+score);
            Greenfoot.stop();
        }

    }    

    public boolean isMousetrapInRange()  
    {  
        return !getObjectsInRange(30, Mousetrap.class).isEmpty();  
    } 

    public boolean isCatInRange()  
    {  
        return !getObjectsInRange(25, Cat.class).isEmpty();  
    }

    private void whoWins(String winner)
    {
        Label theLabel = new Label(winner);

        theLabel.setBackground(Color.WHITE);

        theLabel.setForeground(Color.DARK_GRAY);

        theLabel.setBorder(Color.GRAY);

        theLabel.setWidth(200);

        theLabel.setHeight(75);

        World theWorld = getWorld();

        theWorld.addObject(theLabel, 300, 265);

    }
}
